/**
*COPYRIGHT (C) 2006  Michele Basso   (basso@dsi.unifi.it)
*                    Marco Romagnoli (romagnoli@control.dsi.unifi.it)
*                    Massimo Vassalli(vassalli@inoa.it)
*
*This library is free software; you can redistribute it and/or
*modify it under the terms of the GNU Lesser General Public
*License as published by the Free Software Foundation; either
*version 2 of the License, or (at your option) any later version.
*
*This library is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*Lesser General Public License for more details.
*
*You should have received a copy of the GNU Lesser General Public
*License along with this library; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
**/

#include "XmlRpc.h"
#include "../socket/Socket.h"
#include "../socket/SocketException.h"
#include <iostream>
#include <unistd.h>

using namespace XmlRpc;

int main(int argc, char* argv[])
{
 
  int port_xml=29001;
  std::string server="localhost";
  std::string from_server;
  
  //XmlRpc::setVerbosity(5);

  XmlRpcClient c(server.c_str(), port_xml);
  XmlRpcValue noArgs, result1, result2,result3, appo;

/************ SEND DATA TARGET *************************/
  noArgs[0]="IFTASK";
  if (c.execute("Get_Param", noArgs, result1))
    std::cout << "OK1\n";
  else {
    std::cout << "Error calling 'Get_Param'\n\n";
    exit(1);
  }
  std::cout << "dopo paramtest\n";
/*******************************************************
	result2=result1;
	result2[0]="IFTASK";
//  for(int i=1;i<result2.size();i++) {
	appo[0]=2.0;
	result2[59][4]=appo;
//  }
  if (c.execute("Send_Param", result2, appo))
    std::cout << "ok2 " << appo<<"\n";
  else {
    std::cout << "Error calling 'Send_Param'\n\n";
    exit(1);
  }
  
/************ SEND DATA TARGET *************************
  noArgs.clear();
  noArgs[0]="IFTASK";
  if (c.execute("Get_Param", noArgs, result3))
    std::cout << "ok3\n";
  else {
    std::cout << "Error calling 'Get_Param'\n\n";
    exit(1);
  }
//  std::cout<<"\nuno:"<<result1[])[4]
  */
  std::cout<<"=========================================================================================\n";
  std::cout<<"\t Nome parametro \t\t Parametri \n";
  std::cout<<"======================================================================================================\n";
  for(int i=1;i<result1.size();i++) {
  	std::cout<<i<<") "<<(result1[i])[0]<<"\t\t\t\t"<<(result1[i])[4]<<"\n";
  }
  std::cout<<"======================================================================================================\n";
  std::cout<<"\nNumero del parametro:";
  int temp=0;
  std::cin>>temp;
  std::cout<<"\nNumero del parametro da cambiare: "<<temp;
  std::cout<<"\nValore del parametro:";
  double tempV=0;
  std::cin>>tempV;
  std::cout<<"\nValore del parametro scelto: "<<tempV;
/*******************************************************/
	result2=result1;
	result2[0]="IFTASK";
	appo[0]=tempV;
	result2[temp][4]=appo;
  if (c.execute("Send_Param", result2, appo))
    std::cout << "ok2 " << appo<<"\n";
  else {
    std::cout << "Error calling 'Send_Param'\n\n";
    exit(1);
  }
/************ SEND DATA TARGET *************************/
  noArgs[0]="IFTASK";
  if (c.execute("Get_Param", noArgs, result1))
    std::cout << "OK1\n";
  else {
    std::cout << "Error calling 'Get_Param'\n\n";
    exit(1);
  }
  std::cout << "dopo paramtest\n";
/*******************************************************/
  std::cout<<"=========================================================================================\n";
  std::cout<<"\t Nome parametro \t\t Parametri nuovi\n";
  std::cout<<"======================================================================================================\n";
  for(int i=1;i<result1.size();i++) {
  	std::cout<<i<<") "<<(result1[i])[0]<<"\t\t\t\t"<<(result1[i])[4]<<"\n";
  }
  std::cout<<"======================================================================================================\n";
  
/************ SEND DATA TARGET *************************/
/*  std::cout<<"=========================================================================================\n";
  std::cout<<"\t Parametri vecchi \t\t Parametri spediti \t\t Parametri riletti\n";
  std::cout<<"======================================================================================================\n";
  for(int i=1;i<result1.size();i++) {
  	std::cout<<i<<") "<<(result1[i])[4]<<"\t\t\t\t"<<(result2[i])[4]<<"\t\t\t\t\t"<<(result3[i])[4]<<"\n";
  }
  std::cout<<"======================================================================================================\n";
/*  double prova;
  std::cout<<"\n="<<result1[1][4];
  prova=(double)(result1[1][4][0]);
  std::cout<<"\nprova(0.2)="<<prova<<"\n";
/*******************************************************/
/*  std::cout<<"\n="<<result2[2][0]<<"\n"<<result2[2][1]<<"\n"<<result2[2][2]<<"\n"<<result2[2][3]<<"\n";
  std::cout<<"\n\n="<<result2<<"\n";*/
  return 0;
}
